VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form TimerForm 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00AD6D0F&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Armra's Alarm Clock"
   ClientHeight    =   1800
   ClientLeft      =   555
   ClientTop       =   6270
   ClientWidth     =   4245
   Icon            =   "clock.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   120
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   283
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton AboutButton 
      Caption         =   "?"
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   6
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   180
      Left            =   4080
      TabIndex        =   9
      Top             =   0
      Width           =   180
   End
   Begin VB.CommandButton BrowseButton 
      Caption         =   "Browse"
      Height          =   375
      Left            =   3000
      TabIndex        =   8
      Top             =   1320
      Width           =   735
   End
   Begin MSComDlg.CommonDialog GetFileDialog 
      Left            =   480
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Timer CountdownTimer 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   0
      Top             =   0
   End
   Begin VB.CommandButton TestButton 
      Caption         =   "Test"
      Height          =   375
      Left            =   3720
      TabIndex        =   7
      Top             =   1320
      Width           =   495
   End
   Begin VB.TextBox SoundText 
      Alignment       =   2  'Center
      BackColor       =   &H8000000F&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   330
      Left            =   120
      TabIndex        =   6
      Text            =   "C:\windows\media\chimes.wav"
      Top             =   1320
      Width           =   2775
   End
   Begin VB.CheckBox TopCheck 
      BackColor       =   &H00AD6D0F&
      Caption         =   "Top"
      Height          =   375
      Left            =   3240
      MaskColor       =   &H00C0FFC0&
      TabIndex        =   5
      Top             =   840
      Value           =   1  'Checked
      Width           =   1935
   End
   Begin VB.CheckBox SoundCheck 
      BackColor       =   &H00AD6D0F&
      Caption         =   "Sound"
      Height          =   375
      Left            =   3240
      MaskColor       =   &H00C0FFC0&
      TabIndex        =   4
      Top             =   480
      Value           =   1  'Checked
      Width           =   1935
   End
   Begin VB.CheckBox RepeatCheck 
      BackColor       =   &H00AD6D0F&
      Caption         =   "Repeat"
      Height          =   375
      Left            =   3240
      MaskColor       =   &H00C0FFC0&
      TabIndex        =   3
      Top             =   120
      Value           =   1  'Checked
      Width           =   1935
   End
   Begin VB.CommandButton ClearStop 
      BackColor       =   &H00EBB96D&
      Caption         =   "Clear"
      Height          =   375
      Left            =   1560
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   840
      Width           =   1455
   End
   Begin VB.CommandButton Ready 
      BackColor       =   &H00EBB96D&
      Caption         =   "Ready"
      Height          =   375
      Left            =   240
      MaskColor       =   &H00D1D1D1&
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   840
      Width           =   1215
   End
   Begin VB.TextBox TimerText 
      Alignment       =   2  'Center
      BackColor       =   &H8000000F&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   525
      Left            =   120
      TabIndex        =   0
      Text            =   "00:00:00"
      Top             =   120
      Width           =   2895
   End
End
Attribute VB_Name = "TimerForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Needed APIs
Option Explicit
Private Declare Function GetTickCount Lib "kernel32" () As Long 'Get time
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags_ As Long) As Long 'Set window on top
Private Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As Long, ByVal dwFlags As Long) As Long 'Play sound

'Global variables
Dim StartText As String 'Remembers how long to countdown from
Dim StopPressed As Boolean 'Has stop been pressed?
Dim IsBlinking As Boolean 'Is the clock currently blinking

Private Sub AboutButton_Click()
AboutForm.Show
End Sub

Private Sub TopCheck_Click() 'Put window on top
SetWindowPos Me.hwnd, TopCheck.Value - 2, 0, 0, 0, 0, 83 'HWND_TOPMOST=-1, HWND_TOP=0 - (SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE|SWP_SHOWWINDOW)=(1|2|16|64)
End Sub

Private Sub Ready_Click() 'Start Timer
'Does wav file exist and sound is supposed to play?5
On Error Resume Next
If (SoundText.Text = "" Or Dir(SoundText.Text) = "") And SoundCheck.Value = True Then
    MsgBox "Invalid wave file.", , "Error" 'If not, display error and cancel
    Exit Sub
End If

'Disable buttons and text fields
Ready.Enabled = False
BrowseButton.Enabled = False
SoundText.Enabled = False
RepeatCheck.Enabled = False
SoundCheck.Enabled = False
TopCheck.Enabled = False

'Start counting down
StopPressed = False
StartText = TimerText.Text
ClearStop.Caption = "Stop"
CountdownTimer.Enabled = True
End Sub

Private Sub ClearStop_Click()
If ClearStop.Caption = "Clear" Then 'If on "Clear" set timer to 0
    TimerText.Text = "00:00:00"
Else 'Otherwise, stop the countdown
    'Clear countdown
    ClearStop.Caption = "Clear"
    TimerText.Text = StartText
    CountdownTimer.Enabled = False
    StopPressed = True

    'Enable buttons and text fields
    Ready.Enabled = True
    BrowseButton.Enabled = True
    SoundText.Enabled = True
    RepeatCheck.Enabled = True
    SoundCheck.Enabled = True
    TopCheck.Enabled = True
End If
End Sub

Private Sub TestButton_Click() 'Play the wave file
On Error Resume Next
If SoundText.Text = "" Or Dir(SoundText.Text) = "" Then 'Check if file exists first
    MsgBox "Invalid wave file.", , "Error"
    Exit Sub
End If
PlaySound SoundText.Text, 0, 131075 '(SND_ASYNC|SND_NODEFAULT|SND_FILENAME)=(1|2|0x20000)
End Sub

Private Sub BrowseButton_Click() 'Browse for a file
Dim MyName As String
GetFileDialog.DialogTitle = SoundText.Text
On Error GoTo ExitSub 'If cancel is pressed, skip setting filename
GetFileDialog.ShowOpen
SoundText.Text = GetFileDialog.FileName
ExitSub:
End Sub

Private Sub Form_Activate() 'Load options
'Startup preparations
TopCheck_Click 'Set window on top
StartText = TimerText.Text 'Set the default text
IsBlinking = False
StopPressed = False

'If options file exists, load the filename
Dim OptionsString As String, MyOptions As Byte
On Error Resume Next
If Dir(App.Path + "\Clock_Options.dat") <> "" Then
    OptionsString = String(1024, " ")
    Open App.Path + "\Clock_Options.dat" For Binary As #1
        Get #1, , MyOptions
        Get #1, , OptionsString
    Close #1
    
    'Parse Options
    RepeatCheck.Value = MyOptions And 1 'Bit 1
    SoundCheck.Value = (MyOptions And 2) / 2 'Bit 2
    TopCheck.Value = (MyOptions And 4) / 4 'Bit 3
    SoundText.Text = Mid(OptionsString, 9)
    
    'Confirm inputed text is ok
    TimerText.Text = Mid(OptionsString, 1, 8) 'First 8 chars
    TimerText_Change
    StartText = TimerText.Text 'Set the default text
End If

'Set the browse filters
GetFileDialog.Filter = "Wave Files (*.wav)|*.wav|All Files(*.*)|*.*"
GetFileDialog.DefaultExt = ".wav"
GetFileDialog.CancelError = True
End Sub

Private Sub Form_Unload(Cancel As Integer) 'Write options to file
'Compile options
Dim MyOptions As Byte, MyTextToWrite As String
MyOptions = RepeatCheck.Value * 1 + SoundCheck.Value * 2 + TopCheck.Value * 4 'Bits 1-3
MyTextToWrite = TimerText.Text + SoundText.Text

'Save options
On Error Resume Next
Kill App.Path + "\Clock_Options.dat"
Open App.Path + "\Clock_Options.dat" For Binary As #1
    Put #1, , MyOptions
    Put #1, , MyTextToWrite
Close #1
End 'Force program end
End Sub

Private Sub TimerText_Change() 'Make sure our format stays correct, mainly for pasting and loading from file
If IsBlinking Then Exit Sub 'When blinking, do not check for proper text
If Len(TimerText.Text) <> 8 Then 'If text is not 8 characters long, restore saved text
    TimerText.Text = StartText
    Exit Sub
End If
Dim i As Integer
For i = 1 To 8 'Check all 8 characters and make sure we are in the format xx:xx:xx where x is a digit
    Dim MyLet As String
    MyLet = Mid(TimerText.Text, i, 1) 'Grab digit for later testing
    Select Case i 'Only 2 tests done over 8 letters so do in a loop with 2 cases
        Case 3, 6: If MyLet <> ":" Then i = 20
        Case Else
            If Asc(MyLet) < Asc("0") Or Asc(MyLet) > Asc("9") Then i = 20
    End Select
Next i
If i = 21 Then TimerText.Text = StartText 'If i was set to 20, meaning one of the characters was wrong, restore text
End Sub

Private Sub TimerText_KeyDown(KeyCode As Integer, Shift As Integer) 'Cancel backspace and delete
If KeyCode = 46 Or KeyCode = 8 Then KeyCode = 0
End Sub

Private Sub TimerText_KeyPress(KeyAscii As Integer) 'Format countdown timer
Dim SelStart As Byte
Dim NewString As String
If CountdownTimer.Enabled = True Then 'If in countdown, do nothing
    KeyAscii = 0
    Exit Sub
End If
If KeyAscii >= Asc("0") And KeyAscii <= Asc("9") Then 'If keys 0-9 are pressed, process
    SelStart = TimerText.SelStart 'Our selection position
    If SelStart = 8 Then 'If at the end of the string, do nothing
        KeyAscii = 0
        Exit Sub
    End If
    If SelStart = 2 Or SelStart = 5 Then SelStart = SelStart + 1 'If at a colon : skip to next symbol
    NewString = Left(TimerText.Text, SelStart) + Chr(KeyAscii) + Right(TimerText.Text, 7 - SelStart) 'Insert the character in the selection spot
    If (Val(Mid(NewString, 4, 2)) <= 60) And (Val(Mid(NewString, 7, 2)) <= 60) Then 'Checks for a valid time (seconds and minutes must be less than 60)
        TimerText.Text = NewString
        If SelStart = 1 Or SelStart = 4 Then SelStart = SelStart + 1 'Continue to selection point after colon if in the proper spot
    Else 'Invalid number, beep and stay in same spot
        Beep
        SelStart = SelStart - 1
    End If
    TimerText.SelStart = SelStart + 1 'Continue to next number to edit
End If
If KeyAscii = 13 Then Ready_Click 'If enter is pressed, start the countdown
KeyAscii = 0 'Cancel the keystroke since we take care of the key presses above
StartText = TimerText.Text
End Sub

Private Sub CountdownTimer_Timer()
'Parse hours, minutes, and seconds
Dim hours As Integer
Dim minutes As Integer
Dim seconds As Integer
Dim i As Byte
StopPressed = False
hours = Val(Left(TimerText.Text, InStr(TimerText.Text, ":") - 1))
minutes = Val(Mid(TimerText.Text, InStr(TimerText.Text, ":") + 1, 2))
seconds = Val(Right(TimerText.Text, 2))

If hours = 0 And minutes = 0 And seconds <= 1 Then 'At one second showing, alarm goes off
    Dim StartCount As Long
    Dim TickOn As Byte
    TimerText.Text = "00:00:00"
    DoEvents
    If RepeatCheck.Value = 0 Then 'If we do not repeat, do finish animation
        For i = 1 To 3 'Play sound 3 times
            If SoundCheck.Value = 1 Then PlaySound SoundText.Text, 0, 131074 '(SND_SYNC|SND_NODEFAULT|SND_FILENAME)=(0|2|0x20000)
            DoEvents 'Check for events
            If StopPressed Then Exit Sub 'If stop was pressed, while playing sounds, stop playing sounds and exit
        Next i
        StartCount = GetTickCount
        Do
            If StartCount <= GetTickCount - 500 Then 'Blink each half a second 5 times for time finished
                TickOn = TickOn + 1
                If TickOn And 1 Then
                    IsBlinking = True
                    TimerText.Text = ""
                    IsBlinking = False
                Else
                    TimerText.Text = "00:00:00"
                End If
                StartCount = GetTickCount
            End If
            If StopPressed Then Exit Sub 'If someone presses the stop button, exit
            DoEvents
        Loop Until (TickOn >= 11)
        ClearStop_Click 'Press the stop button to reset all other buttons to work again
    Else 'If set to not repeat, play sound once and repeat
        If SoundCheck.Value = 1 Then PlaySound SoundText.Text, 0, 131075 '(SND_ASYNC|SND_NODEFAULT|SND_FILENAME)=(1|2|0x20000)
        TimerText.Text = StartText
    End If
Else 'Decrement timer
    seconds = seconds - 1 'Decrement seconds
    If seconds = -1 Then 'Decrement minutes
        seconds = 59
        minutes = minutes - 1
    End If
    If minutes = -1 Then 'Decrement hours
        minutes = 59
        hours = hours - 1
    End If
    TimerText.Text = String(2 - Len(Trim(hours)), "0") + Trim(hours) + ":" + String(2 - Len(Trim(minutes)), "0") + Trim(minutes) + ":" + String(2 - Len(Trim(seconds)), "0") + Trim(seconds) 'Reformat countdown timer for new number
End If
End Sub
